// generated from rosidl_generator_c/resource/idl__functions.h.em
// with input from pal_statistics_msgs:msg/StatisticsValues.idl
// generated code does not contain a copyright notice

#ifndef PAL_STATISTICS_MSGS__MSG__DETAIL__STATISTICS_VALUES__FUNCTIONS_H_
#define PAL_STATISTICS_MSGS__MSG__DETAIL__STATISTICS_VALUES__FUNCTIONS_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stdlib.h>

#include "rosidl_runtime_c/visibility_control.h"
#include "pal_statistics_msgs/msg/rosidl_generator_c__visibility_control.h"

#include "pal_statistics_msgs/msg/detail/statistics_values__struct.h"

/// Initialize msg/StatisticsValues message.
/**
 * If the init function is called twice for the same message without
 * calling fini inbetween previously allocated memory will be leaked.
 * \param[in,out] msg The previously allocated message pointer.
 * Fields without a default value will not be initialized by this function.
 * You might want to call memset(msg, 0, sizeof(
 * pal_statistics_msgs__msg__StatisticsValues
 * )) before or use
 * pal_statistics_msgs__msg__StatisticsValues__create()
 * to allocate and initialize the message.
 * \return true if initialization was successful, otherwise false
 */
ROSIDL_GENERATOR_C_PUBLIC_pal_statistics_msgs
bool
pal_statistics_msgs__msg__StatisticsValues__init(pal_statistics_msgs__msg__StatisticsValues * msg);

/// Finalize msg/StatisticsValues message.
/**
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_pal_statistics_msgs
void
pal_statistics_msgs__msg__StatisticsValues__fini(pal_statistics_msgs__msg__StatisticsValues * msg);

/// Create msg/StatisticsValues message.
/**
 * It allocates the memory for the message, sets the memory to zero, and
 * calls
 * pal_statistics_msgs__msg__StatisticsValues__init().
 * \return The pointer to the initialized message if successful,
 * otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_pal_statistics_msgs
pal_statistics_msgs__msg__StatisticsValues *
pal_statistics_msgs__msg__StatisticsValues__create();

/// Destroy msg/StatisticsValues message.
/**
 * It calls
 * pal_statistics_msgs__msg__StatisticsValues__fini()
 * and frees the memory of the message.
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_pal_statistics_msgs
void
pal_statistics_msgs__msg__StatisticsValues__destroy(pal_statistics_msgs__msg__StatisticsValues * msg);

/// Check for msg/StatisticsValues message equality.
/**
 * \param[in] lhs The message on the left hand size of the equality operator.
 * \param[in] rhs The message on the right hand size of the equality operator.
 * \return true if messages are equal, otherwise false.
 */
ROSIDL_GENERATOR_C_PUBLIC_pal_statistics_msgs
bool
pal_statistics_msgs__msg__StatisticsValues__are_equal(const pal_statistics_msgs__msg__StatisticsValues * lhs, const pal_statistics_msgs__msg__StatisticsValues * rhs);

/// Copy a msg/StatisticsValues message.
/**
 * This functions performs a deep copy, as opposed to the shallow copy that
 * plain assignment yields.
 *
 * \param[in] input The source message pointer.
 * \param[out] output The target message pointer, which must
 *   have been initialized before calling this function.
 * \return true if successful, or false if either pointer is null
 *   or memory allocation fails.
 */
ROSIDL_GENERATOR_C_PUBLIC_pal_statistics_msgs
bool
pal_statistics_msgs__msg__StatisticsValues__copy(
  const pal_statistics_msgs__msg__StatisticsValues * input,
  pal_statistics_msgs__msg__StatisticsValues * output);

/// Initialize array of msg/StatisticsValues messages.
/**
 * It allocates the memory for the number of elements and calls
 * pal_statistics_msgs__msg__StatisticsValues__init()
 * for each element of the array.
 * \param[in,out] array The allocated array pointer.
 * \param[in] size The size / capacity of the array.
 * \return true if initialization was successful, otherwise false
 * If the array pointer is valid and the size is zero it is guaranteed
 # to return true.
 */
ROSIDL_GENERATOR_C_PUBLIC_pal_statistics_msgs
bool
pal_statistics_msgs__msg__StatisticsValues__Sequence__init(pal_statistics_msgs__msg__StatisticsValues__Sequence * array, size_t size);

/// Finalize array of msg/StatisticsValues messages.
/**
 * It calls
 * pal_statistics_msgs__msg__StatisticsValues__fini()
 * for each element of the array and frees the memory for the number of
 * elements.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_pal_statistics_msgs
void
pal_statistics_msgs__msg__StatisticsValues__Sequence__fini(pal_statistics_msgs__msg__StatisticsValues__Sequence * array);

/// Create array of msg/StatisticsValues messages.
/**
 * It allocates the memory for the array and calls
 * pal_statistics_msgs__msg__StatisticsValues__Sequence__init().
 * \param[in] size The size / capacity of the array.
 * \return The pointer to the initialized array if successful, otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_pal_statistics_msgs
pal_statistics_msgs__msg__StatisticsValues__Sequence *
pal_statistics_msgs__msg__StatisticsValues__Sequence__create(size_t size);

/// Destroy array of msg/StatisticsValues messages.
/**
 * It calls
 * pal_statistics_msgs__msg__StatisticsValues__Sequence__fini()
 * on the array,
 * and frees the memory of the array.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_pal_statistics_msgs
void
pal_statistics_msgs__msg__StatisticsValues__Sequence__destroy(pal_statistics_msgs__msg__StatisticsValues__Sequence * array);

/// Check for msg/StatisticsValues message array equality.
/**
 * \param[in] lhs The message array on the left hand size of the equality operator.
 * \param[in] rhs The message array on the right hand size of the equality operator.
 * \return true if message arrays are equal in size and content, otherwise false.
 */
ROSIDL_GENERATOR_C_PUBLIC_pal_statistics_msgs
bool
pal_statistics_msgs__msg__StatisticsValues__Sequence__are_equal(const pal_statistics_msgs__msg__StatisticsValues__Sequence * lhs, const pal_statistics_msgs__msg__StatisticsValues__Sequence * rhs);

/// Copy an array of msg/StatisticsValues messages.
/**
 * This functions performs a deep copy, as opposed to the shallow copy that
 * plain assignment yields.
 *
 * \param[in] input The source array pointer.
 * \param[out] output The target array pointer, which must
 *   have been initialized before calling this function.
 * \return true if successful, or false if either pointer
 *   is null or memory allocation fails.
 */
ROSIDL_GENERATOR_C_PUBLIC_pal_statistics_msgs
bool
pal_statistics_msgs__msg__StatisticsValues__Sequence__copy(
  const pal_statistics_msgs__msg__StatisticsValues__Sequence * input,
  pal_statistics_msgs__msg__StatisticsValues__Sequence * output);

#ifdef __cplusplus
}
#endif

#endif  // PAL_STATISTICS_MSGS__MSG__DETAIL__STATISTICS_VALUES__FUNCTIONS_H_
